#(define noStandaloneOutput (if (defined? 'noStandaloneOutput) noStandaloneOutput #f))

#(define windows? (string-prefix-ci? "windows" (utsname:sysname (uname))))

#(if (defined? 'LAYOUT) #f
  (let ((scm-load (lambda (filename) (load (
    string-append
      ; on windows the detection of absolute pathes is broken (cause they start with a drive letter and not with a /)
      ; so we have to use relative pathes for load. That works in frescobaldi, but not if you call lilypond from command line,
      ; with a relative path to the .ly file, so we use absolute pathes on posix systems, where it works.
      (if windows?
        ""
        (string-append (dirname (current-filename)) file-name-separator-string))
      "scm" file-name-separator-string filename
    )))))
    (scm-load "json_parser.scm")
    (scm-load "resolve_inherits.scm")
    (scm-load "yaml_parser.scm")))
#(define AUTHOR_DATA (if (defined? 'AUTHOR_DATA) AUTHOR_DATA (parse-yml-file "../../lilypond-song-includes/data/authors.yml")))
#(define SONG_DATA (if (defined? 'SONG_DATA) SONG_DATA (parse-yml-file "../../lilypond-song-includes/data/songs.yml")))

\include "basic_format_and_style_settings.ly"
\include "eps_file_from_song_dir.ly"
\include "title_with_category_images.ly"
\include "chord_settings.ly"
\include "transposition.ly"
\include "verses_with_chords.ly"
\include "arrows_in_scores.ly"
\include "swing_style.ly"
\include "inline_score.ly"
\include "custom_indentation.ily"

% reset important variables
LAYOUT = \layout { \generalLayout }
HEADER = {}
MUSIC = {}
TEXT = \markuplist {""}

verseChords = {}
firstVoice = {}
global = {}
